"use strict";
/**
 * Database Management API
 * Use the Database Management API to perform tasks such as obtaining performance and resource usage metrics
for a fleet of Managed Databases or a specific Managed Database, creating Managed Database Groups, and
running a SQL job on a Managed Database or Managed Database Group.

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatabaseStorageAggregateMetrics = exports.DatabaseStatus = exports.DatabaseParametersCollection = exports.DatabaseParameterUpdateStatus = exports.DatabaseParameterSummary = exports.DatabaseInstanceHomeMetricsDefinition = exports.DatabaseIOAggregateMetrics = exports.DatabaseHomeMetrics = exports.DatabaseHomeMetricDefinition = exports.DatabaseFleetHealthMetrics = exports.DatabaseCredentials = exports.DataAccessContainerSummary = exports.DataAccessContainerCollection = exports.CreateTablespaceDetails = exports.CreateManagedDatabaseGroupDetails = exports.CreateJobDetails = exports.CreateDbManagementPrivateEndpointDetails = exports.CpuUtilizationAggregateMetrics = exports.ConsumerGroupPrivilegeSummary = exports.ConsumerGroupPrivilegeCollection = exports.CompareType = exports.ClusterCacheMetric = exports.CloneSqlTuningTaskDetails = exports.ChildDatabase = exports.ChangeManagedDatabaseGroupCompartmentDetails = exports.ChangeJobCompartmentDetails = exports.ChangeDbManagementPrivateEndpointCompartmentDetails = exports.ChangeDatabaseParametersDetails = exports.ChangeDatabaseParameterDetails = exports.AwrQueryResult = exports.AwrDbWaitEventSummary = exports.AwrDbWaitEventBucketSummary = exports.AwrDbTopWaitEventSummary = exports.AwrDbSysstatSummary = exports.AwrDbSummary = exports.AwrDbSnapshotSummary = exports.AwrDbSnapshotRangeSummary = exports.AwrDbParameterSummary = exports.AwrDbParameterChangeSummary = exports.AwrDbMetricSummary = exports.AwrDbCpuUsageSummary = exports.AssociatedDatabaseSummary = exports.AssociatedDatabaseCollection = exports.AsmPropertySummary = exports.AsmPropertyCollection = exports.AsmProperty = exports.AllowedParameterValue = exports.AddManagedDatabaseToManagedDatabaseGroupDetails = exports.AddDataFilesDetails = exports.ActivityTimeSeriesMetrics = void 0;
exports.ParameterScope = exports.ObjectPrivilegeSummary = exports.ObjectPrivilegeCollection = exports.MetricStatisticsDefinition = exports.MetricDimensionDefinition = exports.MetricDataPoint = exports.MemoryAggregateMetrics = exports.ManagementOption = exports.ManagedDatabaseSummary = exports.ManagedDatabaseGroupSummary = exports.ManagedDatabaseGroupCollection = exports.ManagedDatabaseGroup = exports.ManagedDatabaseCredential = exports.ManagedDatabaseCollection = exports.ManagedDatabase = exports.LifecycleStates = exports.JobTypes = exports.JobSummary = exports.JobScheduleDetails = exports.JobRunSummary = exports.JobRunCollection = exports.JobRun = exports.JobExecutionsStatusSummaryCollection = exports.JobExecutionsStatusSummary = exports.JobExecutionSummary = exports.JobExecutionResultLocation = exports.JobExecutionResultDetails = exports.JobExecutionCollection = exports.JobExecution = exports.JobDatabase = exports.JobCollection = exports.Job = exports.InstanceDetails = exports.FleetSummary = exports.FleetStatusByCategory = exports.FleetMetricSummaryDefinition = exports.FleetMetricDefinition = exports.FailedConnectionsAggregateMetrics = exports.ExecutionPlanStatsComparision = exports.DropTablespaceDetails = exports.DropSqlTuningTaskDetails = exports.DeploymentType = exports.DbManagementPrivateEndpointSummary = exports.DbManagementPrivateEndpointCollection = exports.DbManagementPrivateEndpoint = exports.Datafile = exports.DatabaseUsageMetrics = exports.DatabaseType = exports.DatabaseTimeAggregateMetrics = exports.DatabaseSubType = void 0;
exports.UpdateDbManagementPrivateEndpointDetails = exports.UpdateDatabaseParametersResult = exports.TimeSeriesMetricDefinition = exports.TimeSeriesMetricDataPoint = exports.TablespaceSummary = exports.TablespaceStorageSize = exports.TablespaceCollection = exports.TablespaceAdminStatus = exports.TablespaceAdminCredentialDetails = exports.Tablespace = exports.SystemPrivilegeSummary = exports.SystemPrivilegeCollection = exports.StatementsAggregateMetrics = exports.StartSqlTuningTaskDetails = exports.SqlTuningTaskStatusTypes = exports.SqlTuningTaskSqlExecutionPlanStep = exports.SqlTuningTaskSqlDetail = exports.SqlTuningTaskReturn = exports.SqlTuningTaskPlanStats = exports.SqlTuningTaskCredentialTypes = exports.SqlTuningTaskCredentialDetails = exports.SqlTuningAdvisorTaskSummaryReportTaskInfo = exports.SqlTuningAdvisorTaskSummaryReportStatistics = exports.SqlTuningAdvisorTaskSummaryReportStatementCounts = exports.SqlTuningAdvisorTaskSummaryReportObjectStatFindingSummary = exports.SqlTuningAdvisorTaskSummaryReportIndexFindingSummary = exports.SqlTuningAdvisorTaskSummaryReport = exports.SqlTuningAdvisorTaskSummaryFindingCounts = exports.SqlTuningAdvisorTaskSummaryFindingBenefits = exports.SqlTuningAdvisorTaskSummary = exports.SqlTuningAdvisorTaskSqlExecutionPlan = exports.SqlTuningAdvisorTaskRecommendationSummary = exports.SqlTuningAdvisorTaskRecommendationCollection = exports.SqlTuningAdvisorTaskFindingSummary = exports.SqlTuningAdvisorTaskFindingCollection = exports.SqlTuningAdvisorTaskCollection = exports.SortOrders = exports.RoleSummary = exports.RoleCollection = exports.ResizeDataFileDetails = exports.ResetDatabaseParametersDetails = exports.RemoveManagedDatabaseFromManagedDatabaseGroupDetails = exports.RemoveDataFileDetails = exports.ProxyUserSummary = exports.ProxyUserCollection = exports.ProxiedForUserSummary = exports.ProxiedForUserCollection = exports.PdbStatusDetails = exports.PdbMetrics = exports.ParentGroup = void 0;
exports.UpdateSqlJobDetails = exports.TablespaceAdminSecretCredentialDetails = exports.TablespaceAdminPasswordCredentialDetails = exports.SqlTuningTaskSecretCredentialDetails = exports.SqlTuningTaskPasswordCredentialDetails = exports.SqlJob = exports.ObjectStorageJobExecutionResultLocation = exports.ObjectStorageJobExecutionResultDetails = exports.ManagedDatabaseSecretCredential = exports.ManagedDatabasePasswordCredential = exports.CreateSqlJobDetails = exports.AwrDbWaitEventCollection = exports.AwrDbWaitEventBucketCollection = exports.AwrDbTopWaitEventCollection = exports.AwrDbSysstatCollection = exports.AwrDbSqlReport = exports.AwrDbSnapshotRangeCollection = exports.AwrDbSnapshotCollection = exports.AwrDbReport = exports.AwrDbParameterCollection = exports.AwrDbParameterChangeCollection = exports.AwrDbMetricCollection = exports.AwrDbCpuUsageCollection = exports.AwrDbCollection = exports.WorkloadType = exports.WorkRequestSummary = exports.WorkRequestStatus = exports.WorkRequestResourceActionType = exports.WorkRequestResource = exports.WorkRequestOperationType = exports.WorkRequestLogEntryCollection = exports.WorkRequestLogEntry = exports.WorkRequestErrorCollection = exports.WorkRequestError = exports.WorkRequestCollection = exports.WorkRequest = exports.UserSummary = exports.UserCollection = exports.User = exports.UpdateTablespaceDetails = exports.UpdateManagedDatabaseGroupDetails = exports.UpdateJobDetails = void 0;
const ActivityTimeSeriesMetrics = __importStar(require("./activity-time-series-metrics"));
exports.ActivityTimeSeriesMetrics = ActivityTimeSeriesMetrics.ActivityTimeSeriesMetrics;
const AddDataFilesDetails = __importStar(require("./add-data-files-details"));
exports.AddDataFilesDetails = AddDataFilesDetails.AddDataFilesDetails;
const AddManagedDatabaseToManagedDatabaseGroupDetails = __importStar(require("./add-managed-database-to-managed-database-group-details"));
exports.AddManagedDatabaseToManagedDatabaseGroupDetails = AddManagedDatabaseToManagedDatabaseGroupDetails.AddManagedDatabaseToManagedDatabaseGroupDetails;
const AllowedParameterValue = __importStar(require("./allowed-parameter-value"));
exports.AllowedParameterValue = AllowedParameterValue.AllowedParameterValue;
const AsmProperty = __importStar(require("./asm-property"));
exports.AsmProperty = AsmProperty.AsmProperty;
const AsmPropertyCollection = __importStar(require("./asm-property-collection"));
exports.AsmPropertyCollection = AsmPropertyCollection.AsmPropertyCollection;
const AsmPropertySummary = __importStar(require("./asm-property-summary"));
exports.AsmPropertySummary = AsmPropertySummary.AsmPropertySummary;
const AssociatedDatabaseCollection = __importStar(require("./associated-database-collection"));
exports.AssociatedDatabaseCollection = AssociatedDatabaseCollection.AssociatedDatabaseCollection;
const AssociatedDatabaseSummary = __importStar(require("./associated-database-summary"));
exports.AssociatedDatabaseSummary = AssociatedDatabaseSummary.AssociatedDatabaseSummary;
const AwrDbCpuUsageSummary = __importStar(require("./awr-db-cpu-usage-summary"));
exports.AwrDbCpuUsageSummary = AwrDbCpuUsageSummary.AwrDbCpuUsageSummary;
const AwrDbMetricSummary = __importStar(require("./awr-db-metric-summary"));
exports.AwrDbMetricSummary = AwrDbMetricSummary.AwrDbMetricSummary;
const AwrDbParameterChangeSummary = __importStar(require("./awr-db-parameter-change-summary"));
exports.AwrDbParameterChangeSummary = AwrDbParameterChangeSummary.AwrDbParameterChangeSummary;
const AwrDbParameterSummary = __importStar(require("./awr-db-parameter-summary"));
exports.AwrDbParameterSummary = AwrDbParameterSummary.AwrDbParameterSummary;
const AwrDbSnapshotRangeSummary = __importStar(require("./awr-db-snapshot-range-summary"));
exports.AwrDbSnapshotRangeSummary = AwrDbSnapshotRangeSummary.AwrDbSnapshotRangeSummary;
const AwrDbSnapshotSummary = __importStar(require("./awr-db-snapshot-summary"));
exports.AwrDbSnapshotSummary = AwrDbSnapshotSummary.AwrDbSnapshotSummary;
const AwrDbSummary = __importStar(require("./awr-db-summary"));
exports.AwrDbSummary = AwrDbSummary.AwrDbSummary;
const AwrDbSysstatSummary = __importStar(require("./awr-db-sysstat-summary"));
exports.AwrDbSysstatSummary = AwrDbSysstatSummary.AwrDbSysstatSummary;
const AwrDbTopWaitEventSummary = __importStar(require("./awr-db-top-wait-event-summary"));
exports.AwrDbTopWaitEventSummary = AwrDbTopWaitEventSummary.AwrDbTopWaitEventSummary;
const AwrDbWaitEventBucketSummary = __importStar(require("./awr-db-wait-event-bucket-summary"));
exports.AwrDbWaitEventBucketSummary = AwrDbWaitEventBucketSummary.AwrDbWaitEventBucketSummary;
const AwrDbWaitEventSummary = __importStar(require("./awr-db-wait-event-summary"));
exports.AwrDbWaitEventSummary = AwrDbWaitEventSummary.AwrDbWaitEventSummary;
const AwrQueryResult = __importStar(require("./awr-query-result"));
exports.AwrQueryResult = AwrQueryResult.AwrQueryResult;
const ChangeDatabaseParameterDetails = __importStar(require("./change-database-parameter-details"));
exports.ChangeDatabaseParameterDetails = ChangeDatabaseParameterDetails.ChangeDatabaseParameterDetails;
const ChangeDatabaseParametersDetails = __importStar(require("./change-database-parameters-details"));
exports.ChangeDatabaseParametersDetails = ChangeDatabaseParametersDetails.ChangeDatabaseParametersDetails;
const ChangeDbManagementPrivateEndpointCompartmentDetails = __importStar(require("./change-db-management-private-endpoint-compartment-details"));
exports.ChangeDbManagementPrivateEndpointCompartmentDetails = ChangeDbManagementPrivateEndpointCompartmentDetails.ChangeDbManagementPrivateEndpointCompartmentDetails;
const ChangeJobCompartmentDetails = __importStar(require("./change-job-compartment-details"));
exports.ChangeJobCompartmentDetails = ChangeJobCompartmentDetails.ChangeJobCompartmentDetails;
const ChangeManagedDatabaseGroupCompartmentDetails = __importStar(require("./change-managed-database-group-compartment-details"));
exports.ChangeManagedDatabaseGroupCompartmentDetails = ChangeManagedDatabaseGroupCompartmentDetails.ChangeManagedDatabaseGroupCompartmentDetails;
const ChildDatabase = __importStar(require("./child-database"));
exports.ChildDatabase = ChildDatabase.ChildDatabase;
const CloneSqlTuningTaskDetails = __importStar(require("./clone-sql-tuning-task-details"));
exports.CloneSqlTuningTaskDetails = CloneSqlTuningTaskDetails.CloneSqlTuningTaskDetails;
const ClusterCacheMetric = __importStar(require("./cluster-cache-metric"));
exports.ClusterCacheMetric = ClusterCacheMetric.ClusterCacheMetric;
const CompareType = __importStar(require("./compare-type"));
exports.CompareType = CompareType.CompareType;
const ConsumerGroupPrivilegeCollection = __importStar(require("./consumer-group-privilege-collection"));
exports.ConsumerGroupPrivilegeCollection = ConsumerGroupPrivilegeCollection.ConsumerGroupPrivilegeCollection;
const ConsumerGroupPrivilegeSummary = __importStar(require("./consumer-group-privilege-summary"));
exports.ConsumerGroupPrivilegeSummary = ConsumerGroupPrivilegeSummary.ConsumerGroupPrivilegeSummary;
const CpuUtilizationAggregateMetrics = __importStar(require("./cpu-utilization-aggregate-metrics"));
exports.CpuUtilizationAggregateMetrics = CpuUtilizationAggregateMetrics.CpuUtilizationAggregateMetrics;
const CreateDbManagementPrivateEndpointDetails = __importStar(require("./create-db-management-private-endpoint-details"));
exports.CreateDbManagementPrivateEndpointDetails = CreateDbManagementPrivateEndpointDetails.CreateDbManagementPrivateEndpointDetails;
const CreateJobDetails = __importStar(require("./create-job-details"));
exports.CreateJobDetails = CreateJobDetails.CreateJobDetails;
const CreateManagedDatabaseGroupDetails = __importStar(require("./create-managed-database-group-details"));
exports.CreateManagedDatabaseGroupDetails = CreateManagedDatabaseGroupDetails.CreateManagedDatabaseGroupDetails;
const CreateTablespaceDetails = __importStar(require("./create-tablespace-details"));
exports.CreateTablespaceDetails = CreateTablespaceDetails.CreateTablespaceDetails;
const DataAccessContainerCollection = __importStar(require("./data-access-container-collection"));
exports.DataAccessContainerCollection = DataAccessContainerCollection.DataAccessContainerCollection;
const DataAccessContainerSummary = __importStar(require("./data-access-container-summary"));
exports.DataAccessContainerSummary = DataAccessContainerSummary.DataAccessContainerSummary;
const DatabaseCredentials = __importStar(require("./database-credentials"));
exports.DatabaseCredentials = DatabaseCredentials.DatabaseCredentials;
const DatabaseFleetHealthMetrics = __importStar(require("./database-fleet-health-metrics"));
exports.DatabaseFleetHealthMetrics = DatabaseFleetHealthMetrics.DatabaseFleetHealthMetrics;
const DatabaseHomeMetricDefinition = __importStar(require("./database-home-metric-definition"));
exports.DatabaseHomeMetricDefinition = DatabaseHomeMetricDefinition.DatabaseHomeMetricDefinition;
const DatabaseHomeMetrics = __importStar(require("./database-home-metrics"));
exports.DatabaseHomeMetrics = DatabaseHomeMetrics.DatabaseHomeMetrics;
const DatabaseIOAggregateMetrics = __importStar(require("./database-io-aggregate-metrics"));
exports.DatabaseIOAggregateMetrics = DatabaseIOAggregateMetrics.DatabaseIOAggregateMetrics;
const DatabaseInstanceHomeMetricsDefinition = __importStar(require("./database-instance-home-metrics-definition"));
exports.DatabaseInstanceHomeMetricsDefinition = DatabaseInstanceHomeMetricsDefinition.DatabaseInstanceHomeMetricsDefinition;
const DatabaseParameterSummary = __importStar(require("./database-parameter-summary"));
exports.DatabaseParameterSummary = DatabaseParameterSummary.DatabaseParameterSummary;
const DatabaseParameterUpdateStatus = __importStar(require("./database-parameter-update-status"));
exports.DatabaseParameterUpdateStatus = DatabaseParameterUpdateStatus.DatabaseParameterUpdateStatus;
const DatabaseParametersCollection = __importStar(require("./database-parameters-collection"));
exports.DatabaseParametersCollection = DatabaseParametersCollection.DatabaseParametersCollection;
const DatabaseStatus = __importStar(require("./database-status"));
exports.DatabaseStatus = DatabaseStatus.DatabaseStatus;
const DatabaseStorageAggregateMetrics = __importStar(require("./database-storage-aggregate-metrics"));
exports.DatabaseStorageAggregateMetrics = DatabaseStorageAggregateMetrics.DatabaseStorageAggregateMetrics;
const DatabaseSubType = __importStar(require("./database-sub-type"));
exports.DatabaseSubType = DatabaseSubType.DatabaseSubType;
const DatabaseTimeAggregateMetrics = __importStar(require("./database-time-aggregate-metrics"));
exports.DatabaseTimeAggregateMetrics = DatabaseTimeAggregateMetrics.DatabaseTimeAggregateMetrics;
const DatabaseType = __importStar(require("./database-type"));
exports.DatabaseType = DatabaseType.DatabaseType;
const DatabaseUsageMetrics = __importStar(require("./database-usage-metrics"));
exports.DatabaseUsageMetrics = DatabaseUsageMetrics.DatabaseUsageMetrics;
const Datafile = __importStar(require("./datafile"));
exports.Datafile = Datafile.Datafile;
const DbManagementPrivateEndpoint = __importStar(require("./db-management-private-endpoint"));
exports.DbManagementPrivateEndpoint = DbManagementPrivateEndpoint.DbManagementPrivateEndpoint;
const DbManagementPrivateEndpointCollection = __importStar(require("./db-management-private-endpoint-collection"));
exports.DbManagementPrivateEndpointCollection = DbManagementPrivateEndpointCollection.DbManagementPrivateEndpointCollection;
const DbManagementPrivateEndpointSummary = __importStar(require("./db-management-private-endpoint-summary"));
exports.DbManagementPrivateEndpointSummary = DbManagementPrivateEndpointSummary.DbManagementPrivateEndpointSummary;
const DeploymentType = __importStar(require("./deployment-type"));
exports.DeploymentType = DeploymentType.DeploymentType;
const DropSqlTuningTaskDetails = __importStar(require("./drop-sql-tuning-task-details"));
exports.DropSqlTuningTaskDetails = DropSqlTuningTaskDetails.DropSqlTuningTaskDetails;
const DropTablespaceDetails = __importStar(require("./drop-tablespace-details"));
exports.DropTablespaceDetails = DropTablespaceDetails.DropTablespaceDetails;
const ExecutionPlanStatsComparision = __importStar(require("./execution-plan-stats-comparision"));
exports.ExecutionPlanStatsComparision = ExecutionPlanStatsComparision.ExecutionPlanStatsComparision;
const FailedConnectionsAggregateMetrics = __importStar(require("./failed-connections-aggregate-metrics"));
exports.FailedConnectionsAggregateMetrics = FailedConnectionsAggregateMetrics.FailedConnectionsAggregateMetrics;
const FleetMetricDefinition = __importStar(require("./fleet-metric-definition"));
exports.FleetMetricDefinition = FleetMetricDefinition.FleetMetricDefinition;
const FleetMetricSummaryDefinition = __importStar(require("./fleet-metric-summary-definition"));
exports.FleetMetricSummaryDefinition = FleetMetricSummaryDefinition.FleetMetricSummaryDefinition;
const FleetStatusByCategory = __importStar(require("./fleet-status-by-category"));
exports.FleetStatusByCategory = FleetStatusByCategory.FleetStatusByCategory;
const FleetSummary = __importStar(require("./fleet-summary"));
exports.FleetSummary = FleetSummary.FleetSummary;
const InstanceDetails = __importStar(require("./instance-details"));
exports.InstanceDetails = InstanceDetails.InstanceDetails;
const Job = __importStar(require("./job"));
exports.Job = Job.Job;
const JobCollection = __importStar(require("./job-collection"));
exports.JobCollection = JobCollection.JobCollection;
const JobDatabase = __importStar(require("./job-database"));
exports.JobDatabase = JobDatabase.JobDatabase;
const JobExecution = __importStar(require("./job-execution"));
exports.JobExecution = JobExecution.JobExecution;
const JobExecutionCollection = __importStar(require("./job-execution-collection"));
exports.JobExecutionCollection = JobExecutionCollection.JobExecutionCollection;
const JobExecutionResultDetails = __importStar(require("./job-execution-result-details"));
exports.JobExecutionResultDetails = JobExecutionResultDetails.JobExecutionResultDetails;
const JobExecutionResultLocation = __importStar(require("./job-execution-result-location"));
exports.JobExecutionResultLocation = JobExecutionResultLocation.JobExecutionResultLocation;
const JobExecutionSummary = __importStar(require("./job-execution-summary"));
exports.JobExecutionSummary = JobExecutionSummary.JobExecutionSummary;
const JobExecutionsStatusSummary = __importStar(require("./job-executions-status-summary"));
exports.JobExecutionsStatusSummary = JobExecutionsStatusSummary.JobExecutionsStatusSummary;
const JobExecutionsStatusSummaryCollection = __importStar(require("./job-executions-status-summary-collection"));
exports.JobExecutionsStatusSummaryCollection = JobExecutionsStatusSummaryCollection.JobExecutionsStatusSummaryCollection;
const JobRun = __importStar(require("./job-run"));
exports.JobRun = JobRun.JobRun;
const JobRunCollection = __importStar(require("./job-run-collection"));
exports.JobRunCollection = JobRunCollection.JobRunCollection;
const JobRunSummary = __importStar(require("./job-run-summary"));
exports.JobRunSummary = JobRunSummary.JobRunSummary;
const JobScheduleDetails = __importStar(require("./job-schedule-details"));
exports.JobScheduleDetails = JobScheduleDetails.JobScheduleDetails;
const JobSummary = __importStar(require("./job-summary"));
exports.JobSummary = JobSummary.JobSummary;
const JobTypes = __importStar(require("./job-types"));
exports.JobTypes = JobTypes.JobTypes;
const LifecycleStates = __importStar(require("./lifecycle-states"));
exports.LifecycleStates = LifecycleStates.LifecycleStates;
const ManagedDatabase = __importStar(require("./managed-database"));
exports.ManagedDatabase = ManagedDatabase.ManagedDatabase;
const ManagedDatabaseCollection = __importStar(require("./managed-database-collection"));
exports.ManagedDatabaseCollection = ManagedDatabaseCollection.ManagedDatabaseCollection;
const ManagedDatabaseCredential = __importStar(require("./managed-database-credential"));
exports.ManagedDatabaseCredential = ManagedDatabaseCredential.ManagedDatabaseCredential;
const ManagedDatabaseGroup = __importStar(require("./managed-database-group"));
exports.ManagedDatabaseGroup = ManagedDatabaseGroup.ManagedDatabaseGroup;
const ManagedDatabaseGroupCollection = __importStar(require("./managed-database-group-collection"));
exports.ManagedDatabaseGroupCollection = ManagedDatabaseGroupCollection.ManagedDatabaseGroupCollection;
const ManagedDatabaseGroupSummary = __importStar(require("./managed-database-group-summary"));
exports.ManagedDatabaseGroupSummary = ManagedDatabaseGroupSummary.ManagedDatabaseGroupSummary;
const ManagedDatabaseSummary = __importStar(require("./managed-database-summary"));
exports.ManagedDatabaseSummary = ManagedDatabaseSummary.ManagedDatabaseSummary;
const ManagementOption = __importStar(require("./management-option"));
exports.ManagementOption = ManagementOption.ManagementOption;
const MemoryAggregateMetrics = __importStar(require("./memory-aggregate-metrics"));
exports.MemoryAggregateMetrics = MemoryAggregateMetrics.MemoryAggregateMetrics;
const MetricDataPoint = __importStar(require("./metric-data-point"));
exports.MetricDataPoint = MetricDataPoint.MetricDataPoint;
const MetricDimensionDefinition = __importStar(require("./metric-dimension-definition"));
exports.MetricDimensionDefinition = MetricDimensionDefinition.MetricDimensionDefinition;
const MetricStatisticsDefinition = __importStar(require("./metric-statistics-definition"));
exports.MetricStatisticsDefinition = MetricStatisticsDefinition.MetricStatisticsDefinition;
const ObjectPrivilegeCollection = __importStar(require("./object-privilege-collection"));
exports.ObjectPrivilegeCollection = ObjectPrivilegeCollection.ObjectPrivilegeCollection;
const ObjectPrivilegeSummary = __importStar(require("./object-privilege-summary"));
exports.ObjectPrivilegeSummary = ObjectPrivilegeSummary.ObjectPrivilegeSummary;
const ParameterScope = __importStar(require("./parameter-scope"));
exports.ParameterScope = ParameterScope.ParameterScope;
const ParentGroup = __importStar(require("./parent-group"));
exports.ParentGroup = ParentGroup.ParentGroup;
const PdbMetrics = __importStar(require("./pdb-metrics"));
exports.PdbMetrics = PdbMetrics.PdbMetrics;
const PdbStatusDetails = __importStar(require("./pdb-status-details"));
exports.PdbStatusDetails = PdbStatusDetails.PdbStatusDetails;
const ProxiedForUserCollection = __importStar(require("./proxied-for-user-collection"));
exports.ProxiedForUserCollection = ProxiedForUserCollection.ProxiedForUserCollection;
const ProxiedForUserSummary = __importStar(require("./proxied-for-user-summary"));
exports.ProxiedForUserSummary = ProxiedForUserSummary.ProxiedForUserSummary;
const ProxyUserCollection = __importStar(require("./proxy-user-collection"));
exports.ProxyUserCollection = ProxyUserCollection.ProxyUserCollection;
const ProxyUserSummary = __importStar(require("./proxy-user-summary"));
exports.ProxyUserSummary = ProxyUserSummary.ProxyUserSummary;
const RemoveDataFileDetails = __importStar(require("./remove-data-file-details"));
exports.RemoveDataFileDetails = RemoveDataFileDetails.RemoveDataFileDetails;
const RemoveManagedDatabaseFromManagedDatabaseGroupDetails = __importStar(require("./remove-managed-database-from-managed-database-group-details"));
exports.RemoveManagedDatabaseFromManagedDatabaseGroupDetails = RemoveManagedDatabaseFromManagedDatabaseGroupDetails.RemoveManagedDatabaseFromManagedDatabaseGroupDetails;
const ResetDatabaseParametersDetails = __importStar(require("./reset-database-parameters-details"));
exports.ResetDatabaseParametersDetails = ResetDatabaseParametersDetails.ResetDatabaseParametersDetails;
const ResizeDataFileDetails = __importStar(require("./resize-data-file-details"));
exports.ResizeDataFileDetails = ResizeDataFileDetails.ResizeDataFileDetails;
const RoleCollection = __importStar(require("./role-collection"));
exports.RoleCollection = RoleCollection.RoleCollection;
const RoleSummary = __importStar(require("./role-summary"));
exports.RoleSummary = RoleSummary.RoleSummary;
const SortOrders = __importStar(require("./sort-orders"));
exports.SortOrders = SortOrders.SortOrders;
const SqlTuningAdvisorTaskCollection = __importStar(require("./sql-tuning-advisor-task-collection"));
exports.SqlTuningAdvisorTaskCollection = SqlTuningAdvisorTaskCollection.SqlTuningAdvisorTaskCollection;
const SqlTuningAdvisorTaskFindingCollection = __importStar(require("./sql-tuning-advisor-task-finding-collection"));
exports.SqlTuningAdvisorTaskFindingCollection = SqlTuningAdvisorTaskFindingCollection.SqlTuningAdvisorTaskFindingCollection;
const SqlTuningAdvisorTaskFindingSummary = __importStar(require("./sql-tuning-advisor-task-finding-summary"));
exports.SqlTuningAdvisorTaskFindingSummary = SqlTuningAdvisorTaskFindingSummary.SqlTuningAdvisorTaskFindingSummary;
const SqlTuningAdvisorTaskRecommendationCollection = __importStar(require("./sql-tuning-advisor-task-recommendation-collection"));
exports.SqlTuningAdvisorTaskRecommendationCollection = SqlTuningAdvisorTaskRecommendationCollection.SqlTuningAdvisorTaskRecommendationCollection;
const SqlTuningAdvisorTaskRecommendationSummary = __importStar(require("./sql-tuning-advisor-task-recommendation-summary"));
exports.SqlTuningAdvisorTaskRecommendationSummary = SqlTuningAdvisorTaskRecommendationSummary.SqlTuningAdvisorTaskRecommendationSummary;
const SqlTuningAdvisorTaskSqlExecutionPlan = __importStar(require("./sql-tuning-advisor-task-sql-execution-plan"));
exports.SqlTuningAdvisorTaskSqlExecutionPlan = SqlTuningAdvisorTaskSqlExecutionPlan.SqlTuningAdvisorTaskSqlExecutionPlan;
const SqlTuningAdvisorTaskSummary = __importStar(require("./sql-tuning-advisor-task-summary"));
exports.SqlTuningAdvisorTaskSummary = SqlTuningAdvisorTaskSummary.SqlTuningAdvisorTaskSummary;
const SqlTuningAdvisorTaskSummaryFindingBenefits = __importStar(require("./sql-tuning-advisor-task-summary-finding-benefits"));
exports.SqlTuningAdvisorTaskSummaryFindingBenefits = SqlTuningAdvisorTaskSummaryFindingBenefits.SqlTuningAdvisorTaskSummaryFindingBenefits;
const SqlTuningAdvisorTaskSummaryFindingCounts = __importStar(require("./sql-tuning-advisor-task-summary-finding-counts"));
exports.SqlTuningAdvisorTaskSummaryFindingCounts = SqlTuningAdvisorTaskSummaryFindingCounts.SqlTuningAdvisorTaskSummaryFindingCounts;
const SqlTuningAdvisorTaskSummaryReport = __importStar(require("./sql-tuning-advisor-task-summary-report"));
exports.SqlTuningAdvisorTaskSummaryReport = SqlTuningAdvisorTaskSummaryReport.SqlTuningAdvisorTaskSummaryReport;
const SqlTuningAdvisorTaskSummaryReportIndexFindingSummary = __importStar(require("./sql-tuning-advisor-task-summary-report-index-finding-summary"));
exports.SqlTuningAdvisorTaskSummaryReportIndexFindingSummary = SqlTuningAdvisorTaskSummaryReportIndexFindingSummary.SqlTuningAdvisorTaskSummaryReportIndexFindingSummary;
const SqlTuningAdvisorTaskSummaryReportObjectStatFindingSummary = __importStar(require("./sql-tuning-advisor-task-summary-report-object-stat-finding-summary"));
exports.SqlTuningAdvisorTaskSummaryReportObjectStatFindingSummary = SqlTuningAdvisorTaskSummaryReportObjectStatFindingSummary.SqlTuningAdvisorTaskSummaryReportObjectStatFindingSummary;
const SqlTuningAdvisorTaskSummaryReportStatementCounts = __importStar(require("./sql-tuning-advisor-task-summary-report-statement-counts"));
exports.SqlTuningAdvisorTaskSummaryReportStatementCounts = SqlTuningAdvisorTaskSummaryReportStatementCounts.SqlTuningAdvisorTaskSummaryReportStatementCounts;
const SqlTuningAdvisorTaskSummaryReportStatistics = __importStar(require("./sql-tuning-advisor-task-summary-report-statistics"));
exports.SqlTuningAdvisorTaskSummaryReportStatistics = SqlTuningAdvisorTaskSummaryReportStatistics.SqlTuningAdvisorTaskSummaryReportStatistics;
const SqlTuningAdvisorTaskSummaryReportTaskInfo = __importStar(require("./sql-tuning-advisor-task-summary-report-task-info"));
exports.SqlTuningAdvisorTaskSummaryReportTaskInfo = SqlTuningAdvisorTaskSummaryReportTaskInfo.SqlTuningAdvisorTaskSummaryReportTaskInfo;
const SqlTuningTaskCredentialDetails = __importStar(require("./sql-tuning-task-credential-details"));
exports.SqlTuningTaskCredentialDetails = SqlTuningTaskCredentialDetails.SqlTuningTaskCredentialDetails;
const SqlTuningTaskCredentialTypes = __importStar(require("./sql-tuning-task-credential-types"));
exports.SqlTuningTaskCredentialTypes = SqlTuningTaskCredentialTypes.SqlTuningTaskCredentialTypes;
const SqlTuningTaskPlanStats = __importStar(require("./sql-tuning-task-plan-stats"));
exports.SqlTuningTaskPlanStats = SqlTuningTaskPlanStats.SqlTuningTaskPlanStats;
const SqlTuningTaskReturn = __importStar(require("./sql-tuning-task-return"));
exports.SqlTuningTaskReturn = SqlTuningTaskReturn.SqlTuningTaskReturn;
const SqlTuningTaskSqlDetail = __importStar(require("./sql-tuning-task-sql-detail"));
exports.SqlTuningTaskSqlDetail = SqlTuningTaskSqlDetail.SqlTuningTaskSqlDetail;
const SqlTuningTaskSqlExecutionPlanStep = __importStar(require("./sql-tuning-task-sql-execution-plan-step"));
exports.SqlTuningTaskSqlExecutionPlanStep = SqlTuningTaskSqlExecutionPlanStep.SqlTuningTaskSqlExecutionPlanStep;
const SqlTuningTaskStatusTypes = __importStar(require("./sql-tuning-task-status-types"));
exports.SqlTuningTaskStatusTypes = SqlTuningTaskStatusTypes.SqlTuningTaskStatusTypes;
const StartSqlTuningTaskDetails = __importStar(require("./start-sql-tuning-task-details"));
exports.StartSqlTuningTaskDetails = StartSqlTuningTaskDetails.StartSqlTuningTaskDetails;
const StatementsAggregateMetrics = __importStar(require("./statements-aggregate-metrics"));
exports.StatementsAggregateMetrics = StatementsAggregateMetrics.StatementsAggregateMetrics;
const SystemPrivilegeCollection = __importStar(require("./system-privilege-collection"));
exports.SystemPrivilegeCollection = SystemPrivilegeCollection.SystemPrivilegeCollection;
const SystemPrivilegeSummary = __importStar(require("./system-privilege-summary"));
exports.SystemPrivilegeSummary = SystemPrivilegeSummary.SystemPrivilegeSummary;
const Tablespace = __importStar(require("./tablespace"));
exports.Tablespace = Tablespace.Tablespace;
const TablespaceAdminCredentialDetails = __importStar(require("./tablespace-admin-credential-details"));
exports.TablespaceAdminCredentialDetails = TablespaceAdminCredentialDetails.TablespaceAdminCredentialDetails;
const TablespaceAdminStatus = __importStar(require("./tablespace-admin-status"));
exports.TablespaceAdminStatus = TablespaceAdminStatus.TablespaceAdminStatus;
const TablespaceCollection = __importStar(require("./tablespace-collection"));
exports.TablespaceCollection = TablespaceCollection.TablespaceCollection;
const TablespaceStorageSize = __importStar(require("./tablespace-storage-size"));
exports.TablespaceStorageSize = TablespaceStorageSize.TablespaceStorageSize;
const TablespaceSummary = __importStar(require("./tablespace-summary"));
exports.TablespaceSummary = TablespaceSummary.TablespaceSummary;
const TimeSeriesMetricDataPoint = __importStar(require("./time-series-metric-data-point"));
exports.TimeSeriesMetricDataPoint = TimeSeriesMetricDataPoint.TimeSeriesMetricDataPoint;
const TimeSeriesMetricDefinition = __importStar(require("./time-series-metric-definition"));
exports.TimeSeriesMetricDefinition = TimeSeriesMetricDefinition.TimeSeriesMetricDefinition;
const UpdateDatabaseParametersResult = __importStar(require("./update-database-parameters-result"));
exports.UpdateDatabaseParametersResult = UpdateDatabaseParametersResult.UpdateDatabaseParametersResult;
const UpdateDbManagementPrivateEndpointDetails = __importStar(require("./update-db-management-private-endpoint-details"));
exports.UpdateDbManagementPrivateEndpointDetails = UpdateDbManagementPrivateEndpointDetails.UpdateDbManagementPrivateEndpointDetails;
const UpdateJobDetails = __importStar(require("./update-job-details"));
exports.UpdateJobDetails = UpdateJobDetails.UpdateJobDetails;
const UpdateManagedDatabaseGroupDetails = __importStar(require("./update-managed-database-group-details"));
exports.UpdateManagedDatabaseGroupDetails = UpdateManagedDatabaseGroupDetails.UpdateManagedDatabaseGroupDetails;
const UpdateTablespaceDetails = __importStar(require("./update-tablespace-details"));
exports.UpdateTablespaceDetails = UpdateTablespaceDetails.UpdateTablespaceDetails;
const User = __importStar(require("./user"));
exports.User = User.User;
const UserCollection = __importStar(require("./user-collection"));
exports.UserCollection = UserCollection.UserCollection;
const UserSummary = __importStar(require("./user-summary"));
exports.UserSummary = UserSummary.UserSummary;
const WorkRequest = __importStar(require("./work-request"));
exports.WorkRequest = WorkRequest.WorkRequest;
const WorkRequestCollection = __importStar(require("./work-request-collection"));
exports.WorkRequestCollection = WorkRequestCollection.WorkRequestCollection;
const WorkRequestError = __importStar(require("./work-request-error"));
exports.WorkRequestError = WorkRequestError.WorkRequestError;
const WorkRequestErrorCollection = __importStar(require("./work-request-error-collection"));
exports.WorkRequestErrorCollection = WorkRequestErrorCollection.WorkRequestErrorCollection;
const WorkRequestLogEntry = __importStar(require("./work-request-log-entry"));
exports.WorkRequestLogEntry = WorkRequestLogEntry.WorkRequestLogEntry;
const WorkRequestLogEntryCollection = __importStar(require("./work-request-log-entry-collection"));
exports.WorkRequestLogEntryCollection = WorkRequestLogEntryCollection.WorkRequestLogEntryCollection;
const WorkRequestOperationType = __importStar(require("./work-request-operation-type"));
exports.WorkRequestOperationType = WorkRequestOperationType.WorkRequestOperationType;
const WorkRequestResource = __importStar(require("./work-request-resource"));
exports.WorkRequestResource = WorkRequestResource.WorkRequestResource;
const WorkRequestResourceActionType = __importStar(require("./work-request-resource-action-type"));
exports.WorkRequestResourceActionType = WorkRequestResourceActionType.WorkRequestResourceActionType;
const WorkRequestStatus = __importStar(require("./work-request-status"));
exports.WorkRequestStatus = WorkRequestStatus.WorkRequestStatus;
const WorkRequestSummary = __importStar(require("./work-request-summary"));
exports.WorkRequestSummary = WorkRequestSummary.WorkRequestSummary;
const WorkloadType = __importStar(require("./workload-type"));
exports.WorkloadType = WorkloadType.WorkloadType;
const AwrDbCollection = __importStar(require("./awr-db-collection"));
exports.AwrDbCollection = AwrDbCollection.AwrDbCollection;
const AwrDbCpuUsageCollection = __importStar(require("./awr-db-cpu-usage-collection"));
exports.AwrDbCpuUsageCollection = AwrDbCpuUsageCollection.AwrDbCpuUsageCollection;
const AwrDbMetricCollection = __importStar(require("./awr-db-metric-collection"));
exports.AwrDbMetricCollection = AwrDbMetricCollection.AwrDbMetricCollection;
const AwrDbParameterChangeCollection = __importStar(require("./awr-db-parameter-change-collection"));
exports.AwrDbParameterChangeCollection = AwrDbParameterChangeCollection.AwrDbParameterChangeCollection;
const AwrDbParameterCollection = __importStar(require("./awr-db-parameter-collection"));
exports.AwrDbParameterCollection = AwrDbParameterCollection.AwrDbParameterCollection;
const AwrDbReport = __importStar(require("./awr-db-report"));
exports.AwrDbReport = AwrDbReport.AwrDbReport;
const AwrDbSnapshotCollection = __importStar(require("./awr-db-snapshot-collection"));
exports.AwrDbSnapshotCollection = AwrDbSnapshotCollection.AwrDbSnapshotCollection;
const AwrDbSnapshotRangeCollection = __importStar(require("./awr-db-snapshot-range-collection"));
exports.AwrDbSnapshotRangeCollection = AwrDbSnapshotRangeCollection.AwrDbSnapshotRangeCollection;
const AwrDbSqlReport = __importStar(require("./awr-db-sql-report"));
exports.AwrDbSqlReport = AwrDbSqlReport.AwrDbSqlReport;
const AwrDbSysstatCollection = __importStar(require("./awr-db-sysstat-collection"));
exports.AwrDbSysstatCollection = AwrDbSysstatCollection.AwrDbSysstatCollection;
const AwrDbTopWaitEventCollection = __importStar(require("./awr-db-top-wait-event-collection"));
exports.AwrDbTopWaitEventCollection = AwrDbTopWaitEventCollection.AwrDbTopWaitEventCollection;
const AwrDbWaitEventBucketCollection = __importStar(require("./awr-db-wait-event-bucket-collection"));
exports.AwrDbWaitEventBucketCollection = AwrDbWaitEventBucketCollection.AwrDbWaitEventBucketCollection;
const AwrDbWaitEventCollection = __importStar(require("./awr-db-wait-event-collection"));
exports.AwrDbWaitEventCollection = AwrDbWaitEventCollection.AwrDbWaitEventCollection;
const CreateSqlJobDetails = __importStar(require("./create-sql-job-details"));
exports.CreateSqlJobDetails = CreateSqlJobDetails.CreateSqlJobDetails;
const ManagedDatabasePasswordCredential = __importStar(require("./managed-database-password-credential"));
exports.ManagedDatabasePasswordCredential = ManagedDatabasePasswordCredential.ManagedDatabasePasswordCredential;
const ManagedDatabaseSecretCredential = __importStar(require("./managed-database-secret-credential"));
exports.ManagedDatabaseSecretCredential = ManagedDatabaseSecretCredential.ManagedDatabaseSecretCredential;
const ObjectStorageJobExecutionResultDetails = __importStar(require("./object-storage-job-execution-result-details"));
exports.ObjectStorageJobExecutionResultDetails = ObjectStorageJobExecutionResultDetails.ObjectStorageJobExecutionResultDetails;
const ObjectStorageJobExecutionResultLocation = __importStar(require("./object-storage-job-execution-result-location"));
exports.ObjectStorageJobExecutionResultLocation = ObjectStorageJobExecutionResultLocation.ObjectStorageJobExecutionResultLocation;
const SqlJob = __importStar(require("./sql-job"));
exports.SqlJob = SqlJob.SqlJob;
const SqlTuningTaskPasswordCredentialDetails = __importStar(require("./sql-tuning-task-password-credential-details"));
exports.SqlTuningTaskPasswordCredentialDetails = SqlTuningTaskPasswordCredentialDetails.SqlTuningTaskPasswordCredentialDetails;
const SqlTuningTaskSecretCredentialDetails = __importStar(require("./sql-tuning-task-secret-credential-details"));
exports.SqlTuningTaskSecretCredentialDetails = SqlTuningTaskSecretCredentialDetails.SqlTuningTaskSecretCredentialDetails;
const TablespaceAdminPasswordCredentialDetails = __importStar(require("./tablespace-admin-password-credential-details"));
exports.TablespaceAdminPasswordCredentialDetails = TablespaceAdminPasswordCredentialDetails.TablespaceAdminPasswordCredentialDetails;
const TablespaceAdminSecretCredentialDetails = __importStar(require("./tablespace-admin-secret-credential-details"));
exports.TablespaceAdminSecretCredentialDetails = TablespaceAdminSecretCredentialDetails.TablespaceAdminSecretCredentialDetails;
const UpdateSqlJobDetails = __importStar(require("./update-sql-job-details"));
exports.UpdateSqlJobDetails = UpdateSqlJobDetails.UpdateSqlJobDetails;
//# sourceMappingURL=index.js.map