/**
 * Identity Service
 * API for the Identity Dataplane
 * OpenAPI spec version: v1
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
export interface CredentialAuthenticatorInfo {
    /**
     * The raw credential.
     */
    "rawCredential": string;
    /**
     * The id of the user.
     */
    "userId": string;
    /**
     * The id of the tenant.
     */
    "tenantId": string;
    /**
     * The name of the user.
     */
    "userName": string;
    /**
     * The name of the tenant.
     */
    "tenantName": string;
    /**
     * The credential identifier.
     */
    "credentialIdentifier": string;
    /**
     * The credential list.
     */
    "credentialList": Array<string>;
    /**
     * The name of the service that is making this authorization request.
     */
    "service": string;
    /**
     * The id of the client.
     */
    "clientId": string;
}
export declare namespace CredentialAuthenticatorInfo {
    function getJsonObj(obj: CredentialAuthenticatorInfo): object;
    function getDeserializedJsonObj(obj: CredentialAuthenticatorInfo): object;
}
