/**
 * Application Dependency Management API
 * Use the Application Dependency Management API to create knowledge bases and vulnerability audits.  For more information, see [ADM](/Content/application-dependency-management/home.htm).
 * OpenAPI spec version: 20220421
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2022, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Configuration for a Vulnerability Audit
 * type: object
 *
 */
export interface VulnerabilityAuditConfiguration {
    /**
     * The minimum CVSS V2 score for a vulnerability to be considered by the audit as failed. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "maxPermissibleCvssV2Score"?: number;
    /**
     * The minimum CVSS V3 score for a vulnerability to be considered by the audit as failed. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "maxPermissibleCvssV3Score"?: number;
    /**
     * Pattern to exclude artifacts from audit.
     */
    "exclusions"?: Array<string>;
}
export declare namespace VulnerabilityAuditConfiguration {
    function getJsonObj(obj: VulnerabilityAuditConfiguration): object;
    function getDeserializedJsonObj(obj: VulnerabilityAuditConfiguration): object;
}
